// RequireJS dependency handling
require (["splunkjs/mvc",
         "splunkjs/mvc/simplexml/ready!"], function (mvc)
{
   //
   // Set tokens depending on whether we are in process or application mode
   //
   var mode = GetToken (mvc, "mode");
   var regex = /[^|]+/;
   var easySplunkVersion = GetEasySplunkVersion (mvc);
   if (mode == "app")
   {
      //
      // App mode
      //
      SetToken (mvc, "ModeLower", gettext("application"));
      SetToken (mvc, "ModeHigher", gettext("Application"));
      SetToken (mvc, "TotalInputDelay", gettext("Total application input delay:"));
      SetToken (mvc, "MaxInputDelay", gettext("Maximum application input delay:"));
      SetToken (mvc, "AvgInputDelay", gettext("Average application input delay:"));
      SetToken (mvc, "InputEvents", gettext("#Application input events:"));
      
      SetToken (mvc, "TokenGroupBy", "AppName");

      // Page title and description
      document.title = document.title.replace (regex, gettext("Application Input Delay "));
      if (easySplunkVersion >= 70300)
      {
         $('.dashboard-header > h1').text (gettext("Application Input Delay"));
      }
      else
      {
         $('.dashboard-header > h2').text (gettext("Application Input Delay"));
      }
      $('.dashboard-header > p.description').text (gettext("This dashboard displays detailed information about the application input delay."));
   }
   else if (mode == "process")
   {
      //
      // Process mode
      //
      SetToken (mvc, "ModeLower", gettext("process"));
      SetToken (mvc, "ModeHigher", gettext("Process"));
      
      SetToken (mvc, "TotalInputDelay", gettext("Total process input delay:"));
      SetToken (mvc, "MaxInputDelay", gettext("Maximum process input delay:"));
      SetToken (mvc, "AvgInputDelay", gettext("Average process input delay:"));
      SetToken (mvc, "InputEvents", gettext("#Process input events:"));
      
      SetToken (mvc, "TokenGroupBy", "ProcName");
      
      // Page title and description
      document.title = document.title.replace (regex, gettext("Process Input Delay "));
      if (easySplunkVersion >= 70300)
      {
         $('.dashboard-header > h1').text (gettext("Process Input Delay"));
      }
      else
      {
         $('.dashboard-header > h2').text (gettext("Process Input Delay"));
      }
      $('.dashboard-header > p.description').text (gettext("This dashboard displays detailed information about the process input delay."));
   }

   //
   // Submit the changed tokens
   //
   SubmitTokens (mvc);
});
