
// RequireJS dependency handling
require (["splunkjs/mvc",
         "splunkjs/mvc/simplexml/ready!",
         "splunkjs/mvc/tokenforwarder"], function (mvc)
{
   // Set click event handlers
   var chart31 = mvc.Components.getInstance ("Chart_Panel31");
   chart31.on ("click", drilldown);
   var chart32 = mvc.Components.getInstance ("Chart_Panel32");
   chart32.on ("click", drilldown);
   var chart41 = mvc.Components.getInstance ("Chart_Panel41");
   chart41.on ("click", drilldown);
   var chart42 = mvc.Components.getInstance ("Chart_Panel42");
   chart42.on ("click", drilldown);
   var table51 = mvc.Components.getInstance ("Table_Panel51");
   table51.on ("click:row", drilldown);

   function drilldown (event)
   {
      event.preventDefault ();

      var earliest = GetToken (mvc, "earliest");
      var latest = GetToken (mvc, "latest");
      var browser = GetToken(mvc, "form.Browser");
      var browserProcessName = "chrome.exe";
      if (browser == "4")
         browserProcessName = "msedge.exe";
      else if (browser == "5")
         browserProcessName = "citrixenterprisebrowser.exe";

      var drilldownUrl = "analyze_timechart";
      drilldownUrl += "?earliest=" + encodeURIComponent (earliest);
      drilldownUrl += "&latest=" + encodeURIComponent (latest);
      drilldownUrl += "&form.FilterDatamodel=" + encodeURIComponent ("Application_BrowserPerformanceChrome");
      drilldownUrl += "&form.FilterField=" + encodeURIComponent ("sProcType");
      drilldownUrl += "&form.FilterOperator=" + encodeURIComponent ("in");
      drilldownUrl += "&form.FilterExpression=" + encodeURIComponent (event.data["click.value"]);
      drilldownUrl += "&form.FilterField2=" + encodeURIComponent ("sBrowserProcName");
      drilldownUrl += "&form.FilterOperator2=" + encodeURIComponent ("in");
      drilldownUrl += "&form.FilterExpression2=" + encodeURIComponent (browserProcessName);
      drilldownUrl += "&form.FilterLevels=2";

      window.open(drilldownUrl);
   }

   var browser = GetToken(mvc, "form.Browser");
   var browserName = "Chrome";
   if (browser == "4")
      browserName = "Edge";
   else if (browser == "5")
      browserName = "CEB";

   var dashboardTitleWithoutBrowserName = gettext("Browser Performance");
   var dashboardTitle = `${dashboardTitleWithoutBrowserName}: ${browserName} `;

   var regex = /[^|]+/;
   document.title = document.title.replace (regex, dashboardTitle);

   var easySplunkVersion = GetEasySplunkVersion (mvc);
   if (easySplunkVersion >= 70300)
   {
      $('.dashboard-header > h1').text (dashboardTitle);
   }
   else
   {
      $('.dashboard-header > h2').text (dashboardTitle);
   }

});
