function ScrollTo(element) {
   $('html, body').animate({
      scrollTop: $(element).offset().top
    }, 1000);
}


require(['jquery', 'underscore', 'splunkjs/mvc', 'splunkjs/mvc/tableview', 'splunkjs/mvc/simplexml/ready!'], function($, _, mvc, TableView)
{
   function UnsetToken(name) {
      var defaultTokenModel = mvc.Components.getInstance('default', {create: true});
      var submittedTokenModel = mvc.Components.getInstance('submitted', {create: true});

      defaultTokenModel.unset(name);
      submittedTokenModel.unset(name);
   }

   function HandlePanel00Filter1Change (model, value)
   {
      // Remove the details panel and reset the description
      UnsetToken ("DrilldownFilterBy1");
      UnsetToken ("DrilldownFilterBy2");
      $('#p01_Panel41').text(gettext("Click on one of the charts above to show more information."));
      $('#p02_Panel41').text("");
   }

   // Get the default token model
   var defaultTokenModel = mvc.Components.get ("default");
   
   // Bind event listener for future changes
   defaultTokenModel.on ("change:Panel00Filter1", HandlePanel00Filter1Change);

   // Set description on details panel
   $('#p01_Panel41').text(gettext("Click on one of the charts above to show more information."));
   $('#p02_Panel41').text("");

   // Custom table renderer
   var TimebarCellRenderer = TableView.BaseCellRenderer.extend(
   {
      // Called to check whether to invoke our custom renderer
      canRender: function(cell)
      {
         return (cell.field === 'Command line');
      },
      
      // The render function is only called when canRender returns true
      render: function($td, cell)
      {
         if (cell.value === null)
         {
            return;
         }

         if (cell.field === 'Command line')
         {
            var message = cell.value;
            var tooltip = cell.value;
            
            message = message.replace ("\\SystemRoot\\System32\\", "...\\");
            message = message.replace ("%SystemRoot%\\system32\\", "...\\");
            message = message.replace ("\\??\\C:\\Windows\\system32\\", "...\\");
            message = message.replace ("C:\\Windows\\system32\\", "...\\");
            message = message.replace ("C:\\Program Files (x86)\\", "...\\");
            message = message.replace ("C:\\Program Files\\", "...\\");
            message = message.replace ("C:\\Windows\\SysWOW64\\", "...\\");
            message = message.replace ("C:\\Windows\\", "...\\");
            if (message.length > 50)
            {
               message = message.substring(0, 49) + "...";
            }
               
            $td.html(_.template('<div title="<%- tooltip %>"> <%- text %></div>',
            {
               text:       message,
               tooltip:    tooltip
            }));
         }
      }
   });

   mvc.Components.get('Table_Panel61').getVisualization(function(tableView)
   {
      // Register custom cell renderer
      tableView.table.addCellRenderer(new TimebarCellRenderer());
      
      // Force the table to re-render
      tableView.table.render();
   });

  // Custom drilldowns
  var ChartPanel11 = mvc.Components.getInstance ("Chart_Panel11");
  ChartPanel11.on ("click", drilldown, {clickedElement: "Chart_Panel11"});

  var ChartPanel31 = mvc.Components.getInstance ("Chart_Panel31");
  ChartPanel31.on ("click", drilldown, {clickedElement: "Chart_Panel31"});

  var ChartPanel21 = mvc.Components.getInstance ("Chart_Panel21");
  ChartPanel21.on ("click", drilldown21);

  function drilldown (event)
  {
   // Don't do any further event processing
   event.preventDefault ();

   // Hide other drilldown panel
   UnsetToken("DrilldownFilterBy2");

   // Reset filters
   UnsetToken ("Panel51ProcessFilterDefault");
   UnsetToken ("form.Panel51ProcessFilter");
   UnsetToken ("Panel51ProcessFilter");

   UnsetToken ("Panel51HostFilterDefault");
   UnsetToken ("form.Panel51HostFilter");
   UnsetToken ("Panel51HostFilter");

   UnsetToken ("form.Panel52MinLengthFilter");
   UnsetToken ("Panel52MinLengthFilter");

   UnsetToken ("form.Panel52MaxLengthFilter");
   UnsetToken ("Panel52MaxLengthFilter");

   var clickedElement = this.clickedElement

   var Panel00Filter1 = GetToken (mvc, "Panel00Filter1");

   if (clickedElement === "Chart_Panel11")
   {
      var DrilldownFilterBy1 = event.data["click.name2"];
      SetToken (mvc, "Panel52MinLengthFilter", "0", submit);
      SetToken (mvc, "form.Panel52MinLengthFilter", "0", submit);

      SetToken (mvc, "Panel52MaxLengthFilter", "255", submit);
      SetToken (mvc, "form.Panel52MaxLengthFilter", "255", submit);

      SetToken (mvc, "Panel53Filter", "1", submit)
      SetToken (mvc, "form.Panel53Filter", "1", submit)

      $('#p02_Panel41').html(gettext(`Source chart: <strong>DNS risk over time</strong>`));
   }
   else
   {
      // Chart_Panel31
      var DrilldownFilterBy1 = event.data["click.value"];
      SetToken (mvc, "Panel52MinLengthFilter", `${event.data["row.Request length (Bytes)"]}`, submit);
      SetToken (mvc, "form.Panel52MinLengthFilter", `${event.data["row.Request length (Bytes)"]}`, submit);

      SetToken (mvc, "Panel52MaxLengthFilter", `${event.data["row.Request length (Bytes)"]}`, submit);
      SetToken (mvc, "form.Panel52MaxLengthFilter", `${event.data["row.Request length (Bytes)"]}`, submit);

      SetToken (mvc, "Panel53Filter", "0", submit)
      SetToken (mvc, "form.Panel53Filter", "0", submit)

      $('#p02_Panel41').html(gettext(`Source chart: <strong>DNS packet size distribution</strong>`));
   }
   

   SetToken (mvc, "DrilldownFilterBy1", DrilldownFilterBy1, submit);
   


   if (Panel00Filter1 == "Process")
   {
      SetToken (mvc, "Panel51ProcessFilter", `${DrilldownFilterBy1}`, submit);
      SetToken (mvc, "form.Panel51ProcessFilter", `${DrilldownFilterBy1}`, submit);
      
      SetToken (mvc, "Panel51HostFilter", "*", submit);
      SetToken (mvc, "form.Panel51HostFilter", "*", submit);

      $('#p01_Panel41').html(gettext(`Clicked entity: <strong>${DrilldownFilterBy1}</strong>`));
   }
   else if (Panel00Filter1 == "Host")
   {
      SetToken (mvc, "Panel51HostFilter", `${DrilldownFilterBy1}`, submit);
      SetToken (mvc, "form.Panel51HostFilter", `${DrilldownFilterBy1}`, submit);
      
      SetToken (mvc, "Panel51ProcessFilter", "*", submit);
      SetToken (mvc, "form.Panel51ProcessFilter", "*", submit);

      $('#p01_Panel41').html(gettext(`Clicked entity: <strong>${DrilldownFilterBy1}</strong>`));
   }
   else
   {
      var DrilldownFilterBy1Splitted = DrilldownFilterBy1.split("@");

      if (DrilldownFilterBy1Splitted)
      {
         SetToken (mvc, "Panel51ProcessFilter", `${DrilldownFilterBy1Splitted[0]}`, submit);
         SetToken (mvc, "form.Panel51ProcessFilter", `${DrilldownFilterBy1Splitted[0]}`, submit);

         SetToken (mvc, "Panel51HostFilter", `${DrilldownFilterBy1Splitted[1]}`, submit);
         SetToken (mvc, "form.Panel51HostFilter", `${DrilldownFilterBy1Splitted[1]}`, submit);
         

         $('#p01_Panel41').html(gettext(`Clicked entity: <strong>${DrilldownFilterBy1Splitted[0]}@${DrilldownFilterBy1Splitted[1]}</strong>`));
      }
      else
      {
         return;
      }
   }
   
   ScrollTo("#Panel41");
   }

  function drilldown21 (event)
  {
      // Don't do any further event processing
      event.preventDefault ();

      // Hide other drilldown panel
      UnsetToken("DrilldownFilterBy1");

      var Panel00Filter1 = GetToken (mvc, "Panel00Filter1");
      var DrilldownFilterBy2 = event.data["click.name2"];
      SetToken (mvc, "DrilldownFilterBy2", DrilldownFilterBy2, submit);
      if (Panel00Filter1 == "Process")
      {
         SetToken (mvc, "Panel71ParentProcessFilter", `${DrilldownFilterBy2}`, submit);
         SetToken (mvc, "form.Panel71ParentProcessFilter", `${DrilldownFilterBy2}`, submit);
         
         SetToken (mvc, "Panel71HostFilter", "*", submit);
         SetToken (mvc, "form.Panel71HostFilter", "*", submit);

         $('#p01_Panel41').html(gettext(`Clicked entity: <strong>${DrilldownFilterBy2}</strong>`));
      }
      else if (Panel00Filter1 == "Host")
      {
         SetToken (mvc, "Panel71ParentProcessFilter", "*", submit);
         SetToken (mvc, "form.Panel71ParentProcessFilter", "*", submit);
         
         SetToken (mvc, "Panel71HostFilter", `${DrilldownFilterBy2}`, submit);
         SetToken (mvc, "form.Panel71HostFilter", `${DrilldownFilterBy2}`, submit);

         $('#p01_Panel41').html(gettext(`Clicked entity: <strong>${DrilldownFilterBy2}</strong>`));
      }
      else
      {
         var DrilldownFilterBy2Splitted = DrilldownFilterBy2.split("@");
         if (DrilldownFilterBy2Splitted)
         {
            SetToken (mvc, "Panel71ParentProcessFilter", `${DrilldownFilterBy2Splitted[0]}`, submit);
            SetToken (mvc, "form.Panel71ParentProcessFilter", `${DrilldownFilterBy2Splitted[0]}`, submit);

            SetToken (mvc, "Panel51HostFilter", `${DrilldownFilterBy2Splitted[1]}`, submit);
            SetToken (mvc, "form.Panel51HostFilter", `${DrilldownFilterBy2Splitted[1]}`, submit);
            
            $('#p01_Panel41').html(gettext(`Clicked entity: <strong>${DrilldownFilterBy2Splitted[0]}@${DrilldownFilterBy2Splitted[1]}</strong>`));
         }
         else
         {
            return;
         }
      }

      $('#p02_Panel41').html(gettext(`Source chart: <strong>Nslookup abuse</strong>`));
      ScrollTo("#Panel41");
  }

  
  


});